#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int n, m, bv;
int k[1024][2], p[1024][2];
int s, t;
vector<int> g[2048];
int rcap[2048][2048], par[2048], maxcap[2048];

bool BFS()
{
     int i, j, u, v;
     queue<int> q;

     for ( i = 0; i <= bv; i++ )
         par[i] = -2;

     par[s] = -1;
     maxcap[s] = INT_MAX;
     q.push( s );
     
     while ( !q.empty() )
     {
           v = q.front();
           q.pop();
           for ( i = 0; i < g[v].size(); i++ )
           {
               u = g[v][i];
               if ( ( par[u] == -2 ) && ( rcap[v][u] > 0 ) )
               {
                    par[u] = v;
                    q.push( u );
                    maxcap[u] = min( maxcap[v], rcap[v][u] );
                    if ( u == t )
                       return true;
               }
           }
     }
     return false;
}

int maxFlow()
{
    int i, j, f;
    int MF = 0;
    
    while ( BFS() )
    {
          f = maxcap[t];
          MF = MF + f;
          
          i = t;
          while ( par[i] != -1 )
          {
                j = par[i];
                rcap[j][i] = rcap[j][i] - f;
                rcap[i][j] = rcap[i][j] + f;
                i = j;
          }
    }
    
    return MF;
}

int main()
{
    int i, j;
    int brr = 0;
    
    cin >> n >> m;

    s = 0;
    t = n + m + 1;
    bv = n + m + 1;

    for ( i = 1; i <= n; i++ )
    {
        scanf( "%d%d", &k[i][0], &k[i][1] );
        if ( k[i][0] > k[i][1] )
           swap( k[i][0], k[i][1] );
        g[s].push_back( i );
        g[i].push_back( s );
        rcap[s][i] = 1;
    }
    for ( j = 1; j <= m; j++ )
    {
        scanf( "%d%d", &p[j][0], &p[j][1] );
        if ( p[j][0] > p[j][1] )
           swap( p[j][0], p[j][1] );
        g[n+j].push_back( t );
        g[t].push_back( n+j );
        rcap[n+j][t] = 1;
    }
    
    for ( i = 1; i <= n; i++ )
        for ( j = 1; j <= m; j++ )
            if ( ( k[i][0] <= p[j][0] ) && ( k[i][1] <= p[j][1] ) )
            {
                 g[i].push_back( n+j );
                 g[n+j].push_back( i );
                 rcap[i][n+j] = 1;
            }
    
    cout << maxFlow() << endl;
    return 0;
}
