/*
 *  Николай Йорданов
 *  10 клас
 *  НЛС 10, Контролно състезание 1
 *  задача cards
 */
#include <iostream>
#include <queue>
#include <vector>
#include <climits>
#include <algorithm>

#define ii pair<int, int>

using namespace std;

int a[2048][2048];
int m, n, t;

int main() {
  cin>>n>>m;
  t = 2005;
  
  vector<ii> cards;
  for(int i=0; i<n; i++) {
    ii card;
    cin>>card.first>>card.second;
    if(card.first > card.second)
      swap(card.first, card.second);
    
    cards.push_back(card);
  }
  
  sort(cards.begin(), cards.end());
    
  
  for(int i=0; i<m; i++) {
    ii p;
    cin>>p.first>>p.second;
    
    for(int j=0; j<n; j++) 
      a[j+1][i+1002] += cards[j]<=p;
  }
  
  
  for(int i=1; i<=n; i++)
    a[0][i] = INT_MAX;
  
  for(int i=0; i<m; i++)
    a[i+1002][t] = 1;
  
  
  bool hasPath = true;
  int maxflow = 0, minflow;
  
  
  
  while(hasPath) {
    
    hasPath = 0;
    minflow = INT_MAX;
    
    queue<int> q;
    q.push(0);
    
    vector<bool> used(2048, 0);
    vector<int> par(2048, -1);
    
    bool notFound = true;
    
    while(q.size() && notFound ) {
      int curr = q.front();
      q.pop();
//       cout<<"* "<<q.size()<<" "<<par[curr]<<" "<<curr<<endl;
     
      
      if(curr == t) {
	hasPath = true;
	break;
      }
      
      for(int i=1; i<=t; i++) {
	if(!used[i] && a[curr][i]) {
// 	  cout<<curr<<" "<<i<<endl;
	  
	  par[i] = curr;
	  used[i] = true;
	  q.push(i);
	  /*
	  if(i == t) {
	    cout<<"!!! "<<par[i]<<endl;
	  }*/
	  
	  minflow = min(minflow, a[curr][i]);
	}
      }
      
    }
    
//     cout<<par[t]<<endl<<"------"<<endl;
    
    if(hasPath) {
      int cc = t;
      while(cc) {
// 	cout<<par[cc]<<" "<<cc<<" "<<a[par[cc]][cc]<<" "<<a[cc][par[cc]]<<"    ---   ";
	a[par[cc]][cc] -= minflow;
	a[cc][par[cc]] += minflow;
	
// 	cout<<" "<<a[par[cc]][cc]<<" "<<a[cc][par[cc]]<<endl;
	cc = par[cc];
      }
      
      maxflow += minflow;
    }    
//     cout<<maxflow<<endl<<"------"<<endl;
  }
  
  cout<<maxflow<<endl;
  
  return 0;
}